diff --git a/src/backend/optimizer/util/relnode.c b/src/backend/optimizer/util/relnode.c
index 674cfc6..065591b 100644
--- a/src/backend/optimizer/util/relnode.c
+++ b/src/backend/optimizer/util/relnode.c
@@ -27,6 +27,8 @@
 #include "optimizer/prep.h"
 #include "optimizer/restrictinfo.h"
 #include "optimizer/tlist.h"
+#include "optimizer/var.h"
+#include "parser/parse_oper.h"
 #include "utils/hsearch.h"
 
 
@@ -125,6 +127,7 @@ build_simple_rel(PlannerInfo *root, int relid, RelOptInfo *parent)
 	rel->cheapest_parameterized_paths = NIL;
 	rel->direct_lateral_relids = NULL;
 	rel->lateral_relids = NULL;
+	rel->gpi = NULL;
 	rel->relid = relid;
 	rel->rtekind = rte->rtekind;
 	/* min_attr, max_attr, attr_needed, attr_widths are set below */
@@ -534,6 +537,7 @@ build_join_rel(PlannerInfo *root,
 				  inner_rel->direct_lateral_relids);
 	joinrel->lateral_relids = min_join_parameterization(root, joinrel->relids,
 														outer_rel, inner_rel);
+	joinrel->gpi = NULL;
 	joinrel->relid = 0;			/* indicates not a baserel */
 	joinrel->rtekind = RTE_JOIN;
 	joinrel->min_attr = 0;
@@ -587,6 +591,36 @@ build_join_rel(PlannerInfo *root,
 	add_placeholders_to_joinrel(root, joinrel, outer_rel, inner_rel);
 
 	/*
+	 * If grouping is not applicable at relation level, try to build grouped
+	 * targets --- both for aggregation and for joining grouped relation to
+	 * non-grouped one.
+	 */
+	if (root->grouped_var_list != NIL)
+	{
+		/*
+		 * TODO Consider if placeholders make sense here. If not, also make
+		 * the related code below conditional.
+		 */
+		prepare_rel_for_grouping(root, joinrel);
+
+		/*
+		 * If the relation appears to be eligible for grouping, joinrel->gpi
+		 * has been initialized. Compute cost of the grouping target.
+		 */
+
+		/*
+		 * TODO Store the costs of GroupedVars separate in GroupedPathInfo and
+		 * only add it to the join cost if its result is actually aggregated.
+		 * In contrast, if the grouped join is formed by joining a group
+		 * relation to non-grouped one, the cost of GroupedVar should not
+		 * included (but width should) because the grouped input relation was
+		 * in charge of evaluation.
+		 */
+		if (joinrel->gpi != NULL)
+			set_pathtarget_cost_width(root, joinrel->gpi->target);
+	}
+
+	/*
 	 * add_placeholders_to_joinrel also took care of adding the ph_lateral
 	 * sets of any PlaceHolderVars computed here to direct_lateral_relids, so
 	 * now we can finish computing that.  This is much like the computation of
@@ -708,6 +742,7 @@ build_child_join_rel(PlannerInfo *root, RelOptInfo *outer_rel,
 	joinrel->cheapest_parameterized_paths = NIL;
 	joinrel->direct_lateral_relids = NULL;
 	joinrel->lateral_relids = NULL;
+	joinrel->gpi = NULL;
 	joinrel->relid = 0;			/* indicates not a baserel */
 	joinrel->rtekind = RTE_JOIN;
 	joinrel->min_attr = 0;
@@ -756,7 +791,6 @@ build_child_join_rel(PlannerInfo *root, RelOptInfo *outer_rel,
 														(Node *) parent_joinrel->joininfo,
 														nappinfos,
 														appinfos);
-	pfree(appinfos);
 
 	/*
 	 * Lateral relids referred in child join will be same as that referred in
@@ -792,10 +826,65 @@ build_child_join_rel(PlannerInfo *root, RelOptInfo *outer_rel,
 	/* Add the relation to the PlannerInfo. */
 	add_join_rel(root, joinrel);
 
+	pfree(appinfos);
+
 	return joinrel;
 }
 
 /*
+ * Initialize GroupedPathInfo of a child relation according to that of the
+ * parent.
+ */
+void
+build_chiid_rel_gpi(PlannerInfo *root, RelOptInfo *child, RelOptInfo *parent,
+					int nappinfos, AppendRelInfo **appinfos)
+{
+	GroupedPathInfo *gpi,
+			   *gpi_parent;
+
+	Assert(child->gpi == NULL);
+
+	gpi_parent = parent->gpi;
+	child->gpi = gpi = makeNode(GroupedPathInfo);
+
+	/*
+	 * Create grouping target translated to the child varnos.
+	 *
+	 * We need a copy of the target so that the translation does not affect
+	 * the parent.
+	 */
+	gpi->target = copy_pathtarget(gpi_parent->target);
+	gpi->target->exprs = (List *)
+		adjust_appendrel_attrs(root,
+							   (Node *) gpi->target->exprs,
+							   nappinfos, appinfos);
+
+	/*
+	 * Non-var grouping expressions need to be translated as well.
+	 */
+	if (gpi_parent->group_exprs != NULL)
+	{
+		gpi->group_exprs = copy_pathtarget(gpi_parent->group_exprs);
+		gpi->group_exprs->exprs = (List *)
+			adjust_appendrel_attrs(root,
+								   (Node *) gpi->group_exprs->exprs,
+								   nappinfos, appinfos);
+	}
+
+	/*
+	 * sortgroupclauses need no kind of translation, so just copy the pointer.
+	 */
+	gpi->sortgroupclauses = gpi_parent->sortgroupclauses;
+
+	/*
+	 * If the output of the child rel's paths should be aggregated,
+	 * sortgrouprefs are also needed. (initialize_grouped_targets should have
+	 * initialized sortgrouprefs of the parent rel.)
+	 */
+	child->reltarget->sortgrouprefs = parent->reltarget->sortgrouprefs;
+}
+
+/*
  * min_join_parameterization
  *
  * Determine the minimum possible parameterization of a joinrel, that is, the
@@ -1748,3 +1837,303 @@ build_joinrel_partition_info(RelOptInfo *joinrel, RelOptInfo *outer_rel,
 		joinrel->nullable_partexprs[cnt] = nullable_partexpr;
 	}
 }
+
+/*
+ * If the relation can produce grouped paths, create GroupedPathInfo for it
+ * and create target for aggregation of the relation output.
+ */
+void
+prepare_rel_for_grouping(PlannerInfo *root, RelOptInfo *rel)
+{
+	List	   *gvis;
+	List	   *aggregates = NIL;
+	List	   *grp_exprs = NIL;
+	bool		found_higher_agg;
+	ListCell   *lc;
+	GroupedPathInfo *gpi;
+	PathTarget *target;
+	List	   *grp_exprs_extra = NIL;
+
+	/*
+	 * The current implementation of aggregation push-down cannot handle
+	 * PlaceHolderVar (PHV).
+	 *
+	 * If we knew that the PHV should be evaluated in this target (and of
+	 * course, if its expression matched some grouping expression or Aggref
+	 * argument), we'd just let initialize_grouped_targets create GroupedVar
+	 * for the corresponding expression (phexpr). On the other hand, if we
+	 * knew that the PHV is evaluated below the current rel, we'd ignore it
+	 * because the referencing GroupedVar would take care of propagation of
+	 * the value to upper joins. (PHV whose ph_eval_at is above the current
+	 * rel make the aggregation push-down impossible in any case because the
+	 * partial aggregation would receive wrong input if we ignored the
+	 * ph_eval_at.)
+	 *
+	 * The problem is that the same PHV can be evaluated in the target of the
+	 * current rel or in that of lower rel --- depending on the input paths.
+	 * For example, consider rel->relids = {A, B, C} and if ph_eval_at = {B,
+	 * C}. Path "A JOIN (B JOIN C)" implies that the PHV is evaluated by the
+	 * "(B JOIN C)", while path "(A JOIN B) JOIN C" evaluates the PHV itself.
+	 */
+	foreach(lc, rel->reltarget->exprs)
+	{
+		Expr	   *expr = lfirst(lc);
+
+		if (IsA(expr, PlaceHolderVar))
+			return;
+	}
+
+	/*
+	 * target_agg will be used to aggregate the output of the current
+	 * relation's paths.
+	 */
+	target = create_empty_pathtarget();
+
+	if (IS_SIMPLE_REL(rel))
+	{
+		RangeTblEntry *rte = root->simple_rte_array[rel->relid];;
+
+		/*
+		 * rtekind != RTE_RELATION case is not supported yet.
+		 */
+		if (rte->rtekind != RTE_RELATION)
+			return;
+	}
+
+	/* Caller should only pass base relations or joins. */
+	Assert(rel->reloptkind == RELOPT_BASEREL ||
+		   rel->reloptkind == RELOPT_JOINREL);
+
+	/*
+	 * If any outer join can set the attribute value to NULL, the Agg plan
+	 * would receive different input at the base rel level.
+	 *
+	 * XXX For RELOPT_JOINREL, do not return if all the joins that can set any
+	 * entry of the grouped target (do we need to postpone this check until
+	 * the grouped target is available, and initialize_grouped_targets_target
+	 * take care?) of this rel to NULL are provably below rel. (It's ok if rel
+	 * is one of these joins.)
+	 */
+	if (bms_overlap(rel->relids, root->nullable_baserels))
+		return;
+
+	/*
+	 * Use equivalence classes to generate additional grouping expressions for
+	 * the current rel. Without these we might not be able to apply
+	 * aggregation to the relation result set.
+	 *
+	 * While create_grouping_expr_grouped_var_infos generates equivalence
+	 * class implied plain-Var grouping expressions at once, doing so for
+	 * generic expressions would be complex and might result in very long list
+	 * to search in. So generate the EC-related grouping expressions for each
+	 * particular set of relids.
+	 */
+	gvis = list_copy(root->grouped_var_list);
+	foreach(lc, root->grouped_var_list)
+	{
+		GroupedVarInfo *gvi = lfirst_node(GroupedVarInfo, lc);
+
+		/* Only interested in grouping expressions. */
+		if (IsA(gvi->gvexpr, Aggref))
+			continue;
+
+		/*
+		 * Should have been processed by
+		 * create_grouping_expr_grouped_var_infos.
+		 */
+		if (IsA(gvi->gvexpr, Var))
+			continue;
+
+		gvi = translate_expression_to_rels(root, gvi, rel->relids);
+		if (gvi != NULL)
+			gvis = lappend(gvis, gvi);
+	}
+
+	/*
+	 * Check if some aggregates or grouping expressions can be evaluated in
+	 * this relation's target, and collect all vars referenced by these
+	 * aggregates / grouping expressions;
+	 */
+	found_higher_agg = false;
+	foreach(lc, gvis)
+	{
+		GroupedVarInfo *gvi = lfirst_node(GroupedVarInfo, lc);
+
+		/*
+		 * The subset includes gv_eval_at uninitialized, which includes
+		 * Aggref.aggstar.
+		 */
+		if (bms_is_subset(gvi->gv_eval_at, rel->relids))
+		{
+			/*
+			 * initialize_grouped_targets will handle plain Var grouping
+			 * expressions because it needs to look them up in
+			 * grouped_var_list anyway.
+			 *
+			 * XXX A plain Var could actually be handled w/o GroupedVar, but
+			 * thus initialize_grouped_targets would have to spend extra
+			 * effort looking for the EC-related vars, instead of relying on
+			 * create_grouping_expr_grouped_var_infos. (Processing of
+			 * particular expression would look different, so we could hardly
+			 * reuse the same piece of code.)
+			 */
+			if (IsA(gvi->gvexpr, Var))
+				continue;
+
+			/*
+			 * Accept the aggregate / grouping expression.
+			 *
+			 * (GroupedVarInfo is more convenient for the next processing than
+			 * Aggref, see add_aggregates_to_grouped_target.)
+			 */
+			if (IsA(gvi->gvexpr, Aggref))
+				aggregates = lappend(aggregates, gvi);
+			else
+				grp_exprs = lappend(grp_exprs, gvi);
+		}
+		else if (bms_overlap(gvi->gv_eval_at, rel->relids) &&
+				 IsA(gvi->gvexpr, Aggref))
+		{
+			/*
+			 * Remember that there is at least one aggregate / grouping
+			 * expression that needs more than this rel.
+			 */
+			found_higher_agg = true;
+		}
+	}
+	list_free(gvis);
+
+	/*
+	 * Give up if some other aggregate(s) need multiple relations including
+	 * the current one. The problem is that grouping of the current relation
+	 * could make some input variables unavailable for the "higher aggregate",
+	 * and it'd also decrease the number of input rows the "higher aggregate"
+	 * receives.
+	 *
+	 * In contrast, grp_exprs is only supposed to contain generic grouping
+	 * expression, so it can be NIL so far. If all the grouping keys are just
+	 * plain Vars, initialize_grouped_targets will take care of them.
+	 */
+	if (found_higher_agg)
+		return;
+
+	/*
+	 * Add plain-var grouping expressions to the target.
+	 */
+	initialize_grouped_target(root, rel, target, &grp_exprs_extra);
+
+	/*
+	 * Grouping makes little sense w/o aggregate function and w/o grouping
+	 * expressions.
+	 *
+	 * This test was postponed because initialize_grouped_targets initializes
+	 * sortgrouprefs of rel->reltarget.  This information is useful to avoid
+	 * final aggregation. In particular, even non-grouped relation (e.g.
+	 * unique index scan) can generate unique values of grouping keys. See
+	 * check_group_key_uniqueness for details.
+	 */
+	if (aggregates == NIL)
+		return;
+
+	/*
+	 * Add (non-Var) grouping expressions (in the form of GroupedVar) to
+	 * target_agg.
+	 *
+	 * Follow the convention that the grouping expressions should precede the
+	 * aggregates.
+	 */
+	add_grouped_vars_to_target(root, target, grp_exprs);
+
+	/*
+	 * Initialize GroupedPathInfo.
+	 */
+	Assert(rel->gpi == NULL);
+	gpi = makeNode(GroupedPathInfo);
+	gpi->pathlist = NIL;
+	gpi->partial_pathlist = NIL;
+	rel->gpi = gpi;
+
+	/*
+	 * Partial aggregation makes no sense w/o grouping expressions.
+	 */
+	if (list_length(target->exprs) == 0)
+	{
+		pfree(rel->gpi);
+		rel->gpi = NULL;
+		return;
+	}
+
+	/*
+	 * If the aggregation target should have extra grouping expressions, add
+	 * them now. This step includes assignment of tleSortGroupRef's which we
+	 * can generate now (the "ordinary" grouping expression are present in the
+	 * target by now).
+	 */
+	if (list_length(grp_exprs_extra) > 0)
+	{
+		Index		sortgroupref;
+
+		/*
+		 * Always start at root->max_sortgroupref. The extra grouping
+		 * expressions aren't used during the final aggregation, so the
+		 * sortgroupref values don't need to be unique across the query. Thus
+		 * we don't have to increase root->max_sortgroupref, which makes
+		 * recognition of the extra grouping expressions pretty easy.
+		 */
+		sortgroupref = root->max_sortgroupref;
+
+		/*
+		 * Generate the SortGroupClause's and add the expressions to the
+		 * target.
+		 */
+		foreach(lc, grp_exprs_extra)
+		{
+			Var		   *var = lfirst_node(Var, lc);
+			SortGroupClause *cl = makeNode(SortGroupClause);
+
+			/*
+			 * TODO Verify that these fields are sufficient for this special
+			 * SortGroupClause.
+			 */
+			cl->tleSortGroupRef = ++sortgroupref;
+			get_sort_group_operators(var->vartype,
+									 false, true, false,
+									 NULL, &cl->eqop, NULL,
+									 &cl->hashable);
+			gpi->sortgroupclauses = lappend(gpi->sortgroupclauses, cl);
+			add_column_to_pathtarget(target, (Expr *) var,
+									 cl->tleSortGroupRef);
+
+			/*
+			 * The aggregation input target must emit this var too.
+			 *
+			 * TODO If the target already contains this var for another reason
+			 * (e.g. a an input for generic grouping expression), it'll
+			 * probably not have sortgrouprefs set. Consider removing that
+			 * (and adjust target width accordingly) so that the var is not
+			 * duplicated.
+			 */
+			add_column_to_pathtarget(rel->reltarget, (Expr *) var,
+									 cl->tleSortGroupRef);
+		}
+	}
+
+	/*
+	 * Add aggregates (in the form of GroupedVar) to the target(s).
+	 */
+	add_grouped_vars_to_target(root, target, aggregates);
+
+	/* TODO Check if copy is needed here. */
+	gpi->target = copy_pathtarget(target);
+
+	/*
+	 * Add the non-Var group expressions to a separate target. If
+	 * rel->reltarget should be used to generate input for partial
+	 * aggregation, the corresponding path should include these expressions.
+	 */
+	if (list_length(grp_exprs) > 0)
+	{
+		rel->gpi->group_exprs = create_empty_pathtarget();
+		add_grouped_vars_to_target(root, rel->gpi->group_exprs, grp_exprs);
+	}
+}
diff --git a/src/backend/optimizer/util/tlist.c b/src/backend/optimizer/util/tlist.c
index 9345891..557d934 100644
--- a/src/backend/optimizer/util/tlist.c
+++ b/src/backend/optimizer/util/tlist.c
@@ -408,6 +408,94 @@ get_sortgrouplist_exprs(List *sgClauses, List *targetList)
 	return result;
 }
 
+/*
+ * get_sortgrouplist_clauses
+ *
+ *		Given a "grouped target" (i.e. target where each non-GroupedVar
+ *		element must have sortgroupref set), build a list of the referencing
+ *		SortGroupClauses, a list of the corresponding grouping expressions and
+ *		a list of aggregate expressions.
+ *
+ *		target_group_clauses can contain a list of target-specific
+ *		SortGroupClause's, which correspond to grouping expressions possibly
+ *		added to the target (i.e. w/o being present in
+ *		root->query->groupClause, see initialize_grouped_targets for
+ *		details.).
+ */
+/* Refine the function name. */
+void
+get_grouping_expressions(PlannerInfo *root, PathTarget *target,
+						 List *target_group_clauses,
+						 List **grouping_clauses, List **grouping_exprs,
+						 List **agg_exprs)
+{
+	ListCell   *l;
+	int			i = 0;
+
+	/* The target should contain at least one grouping column. */
+	Assert(target->sortgrouprefs != NULL);
+
+	foreach(l, target->exprs)
+	{
+		Index		sortgroupref = 0;
+		SortGroupClause *cl;
+		Expr	   *texpr;
+
+		texpr = (Expr *) lfirst(l);
+
+		if (IsA(texpr, GroupedVar) &&
+			IsA(((GroupedVar *) texpr)->gvexpr, Aggref))
+		{
+			/*
+			 * texpr should represent the first aggregate in the targetlist.
+			 */
+			break;
+		}
+
+		/*
+		 * Find the clause by sortgroupref.
+		 */
+		sortgroupref = target->sortgrouprefs[i++];
+
+		/*
+		 * Besides being an aggregate, the target expression should have no
+		 * other reason then being a column of a relation functionally
+		 * dependent on the GROUP BY clause. So it's not actually a grouping
+		 * column.
+		 */
+		if (sortgroupref == 0)
+			continue;
+
+		cl = get_sortgroupref_clause_noerr(sortgroupref, root->parse->groupClause);
+
+		/*
+		 * If query does not have this clause, it must be target-specific.
+		 */
+		if (cl == NULL)
+			cl = get_sortgroupref_clause(sortgroupref, target_group_clauses);
+
+		*grouping_clauses = list_append_unique(*grouping_clauses, cl);
+
+		/*
+		 * Add only unique clauses because of joins (both sides of a join can
+		 * point at the same grouping clause). XXX Is it worth adding a bool
+		 * argument indicating that we're dealing with join right now?
+		 */
+		*grouping_exprs = list_append_unique(*grouping_exprs, texpr);
+	}
+
+	/* Now collect the aggregates. */
+	while (l != NULL)
+	{
+		GroupedVar *gvar = castNode(GroupedVar, lfirst(l));
+
+		/* Currently, GroupedVarInfo can only represent aggregate. */
+		Assert(gvar->agg_partial != NULL);
+		*agg_exprs = lappend(*agg_exprs, gvar->agg_partial);
+		l = lnext(l);
+	}
+}
+
 
 /*****************************************************************************
  *		Functions to extract data from a list of SortGroupClauses
@@ -783,6 +871,147 @@ apply_pathtarget_labeling_to_tlist(List *tlist, PathTarget *target)
 }
 
 /*
+ * Replace each "grouped var" in the source targetlist with the original
+ * expression. If agg_partial is true, restore the partial aggregate as
+ * opposed to the original "simple" one.
+ *
+ * TODO Think of more suitable name undo_grouped_var_substitutions? Also note
+ * that the partial aggregate is retrieved, not the original one.
+ */
+List *
+restore_grouping_expressions(PlannerInfo *root, List *src, bool agg_partial)
+{
+	List	   *result = NIL;
+	ListCell   *l;
+
+	foreach(l, src)
+	{
+		TargetEntry *te,
+				   *te_new;
+		Expr	   *expr_new = NULL;
+
+		te = lfirst_node(TargetEntry, l);
+
+		if (IsA(te->expr, GroupedVar))
+		{
+			GroupedVar *gvar;
+
+			gvar = castNode(GroupedVar, te->expr);
+			if (IsA(gvar->gvexpr, Aggref))
+			{
+				if (agg_partial)
+				{
+					/*
+					 * Partial aggregate should appear in the targetlist so
+					 * that it looks as if convert_combining_aggrefs arranged
+					 * it.
+					 */
+					expr_new = (Expr *) gvar->agg_partial;
+				}
+				else
+					expr_new = gvar->gvexpr;
+			}
+			else
+				expr_new = gvar->gvexpr;
+		}
+
+		/*
+		 * Alternatively --- if the query generates an unique set of grouping
+		 * keys --- the targetlist may contain aggfinalfn referencing the
+		 * partial aggregate. We replace this with the original
+		 * (AGGSPLIT_SIMPLE) aggregate so that set_upper_references find a
+		 * match.
+		 */
+		else if (IS_AGGFINALFN_STANDALONE(te->expr))
+		{
+			FuncExpr   *fexpr = castNode(FuncExpr, te->expr);
+			GroupedVar *gvar = linitial_node(GroupedVar, fexpr->args);
+			Aggref	   *aggref = castNode(Aggref, gvar->gvexpr);
+
+			Assert(fexpr->funcid == aggref->aggfinalfn);
+
+			expr_new = (Expr *) aggref;
+		}
+
+		if (expr_new != NULL)
+		{
+			te_new = flatCopyTargetEntry(te);
+			te_new->expr = (Expr *) expr_new;
+		}
+		else
+			te_new = te;
+		result = lappend(result, te_new);
+	}
+
+	return result;
+}
+
+/*
+ * For each aggregate add GroupedVar to the grouped target.
+ *
+ * Caller passes the aggregates in the form of GroupedVarInfos so that we
+ * don't have to look for gvid.
+ */
+void
+add_grouped_vars_to_target(PlannerInfo *root, PathTarget *target,
+						   List *expressions)
+{
+	ListCell   *lc;
+
+	/* Create the vars and add them to the target. */
+	foreach(lc, expressions)
+	{
+		GroupedVarInfo *gvi;
+		GroupedVar *gvar;
+
+		gvi = lfirst_node(GroupedVarInfo, lc);
+		gvar = makeNode(GroupedVar);
+		gvar->gvid = gvi->gvid;
+		gvar->gvexpr = gvi->gvexpr;
+		gvar->agg_partial = gvi->agg_partial;
+		add_column_to_pathtarget(target, (Expr *) gvar, gvi->sortgroupref);
+	}
+}
+
+/*
+ * Return GroupedVar containing the passed-in expression if one exists, or
+ * NULL if the expression cannot be used as grouping key.
+ *
+ * create_grouping_expr_grouped_var_infos should have been called before this
+ * function gets called the first time.
+ */
+GroupedVar *
+get_grouping_expression(PlannerInfo *root, Expr *expr)
+{
+	ListCell   *lc;
+
+	/* Caller should have noticed the empty list much earlier. */
+	Assert(root->grouped_var_list != NIL);
+
+	foreach(lc, root->grouped_var_list)
+	{
+		GroupedVarInfo *gvi = lfirst_node(GroupedVarInfo, lc);
+
+		if (IsA(gvi->gvexpr, Aggref))
+			continue;
+
+		if (equal(gvi->gvexpr, expr))
+		{
+			GroupedVar *result = makeNode(GroupedVar);
+
+			Assert(gvi->sortgroupref > 0);
+			result->gvexpr = gvi->gvexpr;
+			result->gvid = gvi->gvid;
+			result->sortgroupref = gvi->sortgroupref;
+			return result;
+		}
+	}
+
+	/* The expression cannot be used as grouping key. */
+	return NULL;
+}
+
+/*
  * split_pathtarget_at_srfs
  *		Split given PathTarget into multiple levels to position SRFs safely
  *
diff --git a/src/backend/optimizer/util/var.c b/src/backend/optimizer/util/var.c
index 81c60dc..8ecb21d 100644
--- a/src/backend/optimizer/util/var.c
+++ b/src/backend/optimizer/util/var.c
@@ -840,3 +840,25 @@ alias_relid_set(PlannerInfo *root, Relids relids)
 	}
 	return result;
 }
+
+/*
+ * Return GroupedVarInfo for given GroupedVar.
+ *
+ * XXX Consider better location of this routine.
+ */
+GroupedVarInfo *
+find_grouped_var_info(PlannerInfo *root, GroupedVar *gvar)
+{
+	ListCell   *l;
+
+	foreach(l, root->grouped_var_list)
+	{
+		GroupedVarInfo *gvi = lfirst_node(GroupedVarInfo, l);
+
+		if (gvi->gvid == gvar->gvid)
+			return gvi;
+	}
+
+	elog(ERROR, "GroupedVarInfo not found");
+	return NULL;				/* keep compiler quiet */
+}
diff --git a/src/backend/parser/parse_func.c b/src/backend/parser/parse_func.c
index 2f20516..5be42e6 100644
--- a/src/backend/parser/parse_func.c
+++ b/src/backend/parser/parse_func.c
@@ -98,6 +98,8 @@ ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
 	Oid			vatype;
 	FuncDetailCode fdresult;
 	char		aggkind = 0;
+	Oid			aggcombinefn = InvalidOid;
+	Oid			aggfinalfn = InvalidOid;
 	ParseCallbackState pcbstate;
 
 	/*
@@ -341,6 +343,8 @@ ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
 			elog(ERROR, "cache lookup failed for aggregate %u", funcid);
 		classForm = (Form_pg_aggregate) GETSTRUCT(tup);
 		aggkind = classForm->aggkind;
+		aggcombinefn = classForm->aggcombinefn;
+		aggfinalfn = classForm->aggfinalfn;
 		catDirectArgs = classForm->aggnumdirectargs;
 		ReleaseSysCache(tup);
 
@@ -686,6 +690,8 @@ ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
 		aggref->aggstar = agg_star;
 		aggref->aggvariadic = func_variadic;
 		aggref->aggkind = aggkind;
+		aggref->aggcombinefn = aggcombinefn;
+		aggref->aggfinalfn = aggfinalfn;
 		/* agglevelsup will be set by transformAggregateCall */
 		aggref->aggsplit = AGGSPLIT_SIMPLE; /* planner might change this */
 		aggref->location = location;
diff --git a/src/backend/utils/adt/ruleutils.c b/src/backend/utils/adt/ruleutils.c
index 8514c21..ad8a0b9 100644
--- a/src/backend/utils/adt/ruleutils.c
+++ b/src/backend/utils/adt/ruleutils.c
@@ -7647,6 +7647,23 @@ get_rule_expr(Node *node, deparse_context *context,
 			get_agg_expr((Aggref *) node, context, (Aggref *) node);
 			break;
 
+		case T_GroupedVar:
+			{
+				GroupedVar *gvar = castNode(GroupedVar, node);
+				Expr	   *expr = gvar->gvexpr;
+
+				if (IsA(expr, Aggref))
+					get_agg_expr(gvar->agg_partial, context, (Aggref *) gvar->gvexpr);
+				else if (IsA(expr, Var))
+					(void) get_variable((Var *) expr, 0, false, context);
+				else
+				{
+					Assert(IsA(gvar->gvexpr, OpExpr));
+					get_oper_expr((OpExpr *) expr, context);
+				}
+				break;
+			}
+
 		case T_GroupingFunc:
 			{
 				GroupingFunc *gexpr = (GroupingFunc *) node;
@@ -9132,10 +9149,18 @@ get_agg_combine_expr(Node *node, deparse_context *context, void *private)
 	Aggref	   *aggref;
 	Aggref	   *original_aggref = private;
 
-	if (!IsA(node, Aggref))
+	if (IsA(node, Aggref))
+		aggref = (Aggref *) node;
+	else if (IsA(node, GroupedVar))
+	{
+		GroupedVar *gvar = castNode(GroupedVar, node);
+
+		aggref = gvar->agg_partial;
+		original_aggref = castNode(Aggref, gvar->gvexpr);
+	}
+	else
 		elog(ERROR, "combining Aggref does not point to an Aggref");
 
-	aggref = (Aggref *) node;
 	get_agg_expr(aggref, context, original_aggref);
 }
 
diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index ea95b80..87dec17 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -114,6 +114,7 @@
 #include "catalog/pg_statistic_ext.h"
 #include "catalog/pg_type.h"
 #include "executor/executor.h"
+#include "executor/nodeAgg.h"
 #include "mb/pg_wchar.h"
 #include "miscadmin.h"
 #include "nodes/makefuncs.h"
@@ -3863,6 +3864,39 @@ estimate_hash_bucket_stats(PlannerInfo *root, Node *hashkey, double nbuckets,
 	ReleaseVariableStats(vardata);
 }
 
+/*
+ * estimate_hashagg_tablesize
+ *	  estimate the number of bytes that a hash aggregate hashtable will
+ *	  require based on the agg_costs, path width and dNumGroups.
+ *
+ * XXX this may be over-estimating the size now that hashagg knows to omit
+ * unneeded columns from the hashtable. Also for mixed-mode grouping sets,
+ * grouping columns not in the hashed set are counted here even though hashagg
+ * won't store them. Is this a problem?
+ */
+Size
+estimate_hashagg_tablesize(Path *path, const AggClauseCosts *agg_costs,
+						   double dNumGroups)
+{
+	Size		hashentrysize;
+
+	/* Estimate per-hash-entry space at tuple width... */
+	hashentrysize = MAXALIGN(path->pathtarget->width) +
+		MAXALIGN(SizeofMinimalTupleHeader);
+
+	/* plus space for pass-by-ref transition values... */
+	hashentrysize += agg_costs->transitionSpace;
+	/* plus the per-hash-entry overhead */
+	hashentrysize += hash_agg_entry_size(agg_costs->numAggs);
+
+	/*
+	 * Note that this disregards the effect of fill-factor and growth policy
+	 * of the hash-table. That's probably ok, given default the default
+	 * fill-factor is relatively high. It'd be hard to meaningfully factor in
+	 * "double-in-size" growth policies here.
+	 */
+	return hashentrysize * dNumGroups;
+}
 
 /*-------------------------------------------------------------------------
  *
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
index 6dcd738..c6da037 100644
--- a/src/backend/utils/misc/guc.c
+++ b/src/backend/utils/misc/guc.c
@@ -920,6 +920,15 @@ static struct config_bool ConfigureNamesBool[] =
 		false,
 		NULL, NULL, NULL
 	},
+	{
+		{"enable_agg_pushdown", PGC_USERSET, QUERY_TUNING_METHOD,
+			gettext_noop("Enables aggregation push-down."),
+			NULL
+		},
+		&enable_agg_pushdown,
+		false,
+		NULL, NULL, NULL
+	},
 
 	{
 		{"geqo", PGC_USERSET, QUERY_TUNING_GEQO,
diff --git a/src/include/foreign/fdwapi.h b/src/include/foreign/fdwapi.h
index 04e43cc..16d6082 100644
--- a/src/include/foreign/fdwapi.h
+++ b/src/include/foreign/fdwapi.h
@@ -26,11 +26,13 @@ struct ExplainState;
 
 typedef void (*GetForeignRelSize_function) (PlannerInfo *root,
 											RelOptInfo *baserel,
-											Oid foreigntableid);
+											Oid foreigntableid,
+											bool grouped);
 
 typedef void (*GetForeignPaths_function) (PlannerInfo *root,
 										  RelOptInfo *baserel,
-										  Oid foreigntableid);
+										  Oid foreigntableid,
+										  bool grouped);
 
 typedef ForeignScan *(*GetForeignPlan_function) (PlannerInfo *root,
 												 RelOptInfo *baserel,
@@ -57,7 +59,8 @@ typedef void (*GetForeignJoinPaths_function) (PlannerInfo *root,
 											  RelOptInfo *outerrel,
 											  RelOptInfo *innerrel,
 											  JoinType jointype,
-											  JoinPathExtraData *extra);
+											  JoinPathExtraData *extra,
+											  bool grouped);
 
 typedef void (*GetForeignUpperPaths_function) (PlannerInfo *root,
 											   UpperRelationKind stage,
diff --git a/src/include/nodes/nodes.h b/src/include/nodes/nodes.h
index c5b5115..86693d1 100644
--- a/src/include/nodes/nodes.h
+++ b/src/include/nodes/nodes.h
@@ -218,6 +218,7 @@ typedef enum NodeTag
 	T_IndexOptInfo,
 	T_ForeignKeyOptInfo,
 	T_ParamPathInfo,
+	T_GroupedPathInfo,
 	T_Path,
 	T_IndexPath,
 	T_BitmapHeapPath,
@@ -258,10 +259,12 @@ typedef enum NodeTag
 	T_PathTarget,
 	T_RestrictInfo,
 	T_PlaceHolderVar,
+	T_GroupedVar,
 	T_SpecialJoinInfo,
 	T_AppendRelInfo,
 	T_PartitionedChildRelInfo,
 	T_PlaceHolderInfo,
+	T_GroupedVarInfo,
 	T_MinMaxAggInfo,
 	T_PlannerParamItem,
 	T_RollupData,
diff --git a/src/include/nodes/primnodes.h b/src/include/nodes/primnodes.h
index 074ae0a..9959dee 100644
--- a/src/include/nodes/primnodes.h
+++ b/src/include/nodes/primnodes.h
@@ -296,6 +296,8 @@ typedef struct Aggref
 	Oid			aggcollid;		/* OID of collation of result */
 	Oid			inputcollid;	/* OID of collation that function should use */
 	Oid			aggtranstype;	/* type Oid of aggregate's transition value */
+	Oid			aggcombinefn;	/* combine function (see pg_aggregate.h) */
+	Oid			aggfinalfn;		/* final function (see pg_aggregate.h) */
 	List	   *aggargtypes;	/* type Oids of direct and aggregated args */
 	List	   *aggdirectargs;	/* direct arguments, if an ordered-set agg */
 	List	   *args;			/* aggregated arguments and sort expressions */
@@ -306,6 +308,7 @@ typedef struct Aggref
 	bool		aggvariadic;	/* true if variadic arguments have been
 								 * combined into an array last argument */
 	char		aggkind;		/* aggregate kind (see pg_aggregate.h) */
+
 	Index		agglevelsup;	/* > 0 if agg belongs to outer query */
 	AggSplit	aggsplit;		/* expected agg-splitting mode of parent Agg */
 	int			location;		/* token location, or -1 if unknown */
@@ -459,6 +462,14 @@ typedef struct FuncExpr
 } FuncExpr;
 
 /*
+ * Is the expression an aggfinalfn function that can replace the final
+ * aggregation in some cases?
+ */
+#define IS_AGGFINALFN_STANDALONE(e) \
+	(IsA((e), FuncExpr) && list_length(((FuncExpr *) (e))->args) == 1 &&\
+	 IsA(linitial(((FuncExpr *) (e))->args), GroupedVar))
+
+/*
  * NamedArgExpr - a named argument of a function
  *
  * This node type can only appear in the args list of a FuncCall or FuncExpr
